unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Menus;

type
  TForm1 = class(TForm)
    ScrollBox1: TScrollBox;
    Image1: TImage;
    OpenDialog1: TOpenDialog;
    MainMenu1: TMainMenu;
    Open1: TMenuItem;
    N1: TMenuItem;
    procedure Open1Click(Sender: TObject);
    procedure N1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;
          
var
  Form1: TForm1;

implementation

uses
 EffectBass;

{$R *.DFM}


//------------------------------------------------------------------------------
// ֐    EffectGrayScaleColor
// pr      OCXP[J[
// 
//             hBMP             ...Ώۃrbg}bṽnh
// ߂l@
//             rbg}bṽnh
// -----------------------------------------------------------------------------
function EffectGrayScaleColor(hBMP :HBitmap):HBitmap;
var
  Row,Col        : Integer;
  SrcRow,DestRow : pRGBArray;
  RGBColor       : BYTE;
  SrcBitmap,DestBitmap : TBitmap;
begin
  SrcBitmap   :=TBitmap.Create;
  DestBitmap  :=TBitmap.Create;
  SrcBitmap.handle :=hBMP;
  Set24bit(SrcBitmap,DestBitmap);
try
  for Row:=0 to SrcBitmap.Height-1 do
  begin
    SrcRow:=SrcBitmap.ScanLine[Row];
    DestRow:=DestBitmap.ScanLine[Row];
    for Col:=0 to SrcBitmap.Width-1 do
    begin
      //NTSCndϖ@păO[XP[
      RGBColor:=Set255(
                  (Round(SrcRow[Col].rgbtRed   *0.289+
                         SrcRow[Col].rgbtGreen *0.586+
                         SrcRow[Col].rgbtBlue  *0.114 )));

     //PO[XP[
     //RGBColor:=Set255(
     //             (SrcRow[Col].rgbtRed   +
     //              SrcRow[Col].rgbtGreen +
     //              SrcRow[Col].rgbtBlue ) div 3);

      DestRow[Col].rgbtBlue :=RGBColor;
      DestRow[Col].rgbtGreen:=RGBColor;
      DestRow[Col].rgbtRed  :=RGBColor;
    end;
  end;
  Result :=DestBitmap.ReleaseHandle;
except
  Result :=SrcBitmap.ReleaseHandle;
end;
  SrcBitmap.Free ;
  DestBitmap.Free;
end;


/////////
procedure TForm1.Open1Click(Sender: TObject);
begin
 if OpenDialog1.Execute then
 begin
   Image1.Picture.bitmap.LoadFromFIle(OpenDialog1.FIlename);
   N1.Enabled :=true;
 end;
end;

/////////
procedure TForm1.N1Click(Sender: TObject);
begin
 Image1.Picture.bitmap.Handle:= EffectGrayScaleColor(Image1.Picture.Bitmap.ReleaseHandle);
end;

end.
